Bug 487907 - Patch to provide INT13 LBA48 extensions to Xen HVM BIOS (boot off disks/images larger than 128GB)
Patch to provide INT13 LBA48 extensions to Xen HVM BIOS (boot off disks/image...
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: xen (Show other bugs)
5.2
All Linux
low Severity high
: rc
: ---
Assigned To: Michal Novotny
Virtualization Bugs
:
Depends On:
Blocks: 477162
  Show dependency treegraph
 
Reported: 2009-03-01 04:42 EST by David Herselman
Modified: 2014-02-02 17:37 EST (History)
5 users (show)

See Also:
Fixed In Version: xen-3.0.3-84.el5
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-09-02 06:11:43 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Xen HVM romBIOS patch to provide INT13 LBA48 extensions (3.84 KB, patch)
2009-03-01 04:42 EST, David Herselman
no flags Details | Diff
Recompiled /usr/lib/xen/boot/hvmloader - includes INT13 LBA48 (96.19 KB, application/octet-stream)
2009-03-01 04:54 EST, David Herselman
no flags Details

  None (edit)
Description David Herselman 2009-03-01 04:42:13 EST
Created attachment 333638 [details]
Xen HVM romBIOS patch to provide INT13 LBA48 extensions

Please consider adding this patch to Xen as a standard. This would add support for the Xen HVM romBIOS to support disks up to 2TB (2048GB) instead of the current 128GB limit.


Description of problem:
  Xen HVM romBIOS does not have INT13 LBA48 extensions and can thus only boot
  off drives smaller than 128GB reliably. Performing a P2V (Physical to
  Virtual) migration of an existing system may result in it being bootable but
  should the virtual machine's MBR ever be updated the machine would no longer
  be bootable.

Version-Release number of selected component (if applicable):
  3.0.3-64.el5_2.9

How reproducible:
  Always, disks between 128GB and 256GB have their size incorrectly
  displayed in the HVM romBIOS's summary screen but may still work.
  Disks/images larger than 256GB never work though.


Steps to Reproduce:
1. Create a 400GB virtual disk image
     Quick create (do not use in production systems):
       dd if=/dev/zero of=hda.img bs=1M seek=400K count=1
2. Boot off Windows 2003 R2 SP2 CD and install windows
3. After initially partitioning, formatting and copying required files
   the windows installed restarts the system to continue setup from the
   disk, the virtual machine will lockup at bootup as the BIOS can not
   load the required kernel from where the MBR point to as the drive
   geometry is not calculated correctly.
  
Actual results:
  System locks up or experiences problems loading properly

Expected results:
  Should just work

Additional info:
  Easily fixed by recompiling Xen after applying the attached patch file.
  The patch is a copy from a post by Keir Fraser, in January 2008, to add
  INT13 LBA48 extensions to the Xen HVM BIOS.

  Original URL:
  http://lists.xensource.com/archives/html/xen-changelog/2008-01/msg00041.html 

  Originally submitted by:
    # HG changeset patch
    # User Keir Fraser <keir.fraser@xxxxxxxxxx>
    # Date 1198794892 0
    # Node ID 044723b2ab496c31bafcd66c1fbb643f8ca65250
    # Parent 851d07920758adcb08a9f551e147be5279155e88
Comment 1 David Herselman 2009-03-01 04:54:30 EST
Created attachment 333641 [details]
Recompiled /usr/lib/xen/boot/hvmloader  - includes INT13 LBA48

Replacement Xen HVM romBIOS which support INT13 LBA48 extensions to correctly calculate drive geometry for disks/images larger than 128GB (should work with disks of up to 2TB (2048GB)).

Compiled from SRPM: xen-3.0.3-64.el5_2.9

Directions of use:
  replace existing /usr/lib/xen/boot/hvmloader file and create domU

Notes:
  Pretty sure this is platform independent as the domU instance is already
  being virtualised at this stage.
Comment 4 Michal Novotny 2009-03-20 07:53:50 EDT
I have tested this patch and it's working fine in Xen HVMBIOS although initially my machine saw only 16G disk and finally after applying this patch it was able to see 400G disk. I have formatted and mounted it and `df` showed me size of 400G in total. All disk I/O operations I tried were working fine, no problems occured at all.

Michal
Comment 5 Jiri Denemark 2009-04-29 13:24:04 EDT
Fix built into xen-3.0.3-84.el5
Comment 7 Yewei Shao 2009-07-28 04:12:04 EDT
Verified on xen-3.0.3-91.el5
Comment 9 errata-xmlrpc 2009-09-02 06:11:43 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHBA-2009-1328.html

Note You need to log in before you can comment on or make changes to this bug.